package com.iconplus.smartproc.service;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.model.request.UsersRequest;
import com.iconplus.smartproc.repository.BidangRepository;
import com.iconplus.smartproc.repository.InstansiRepository;
import com.iconplus.smartproc.repository.RolesRepository;
import com.iconplus.smartproc.repository.UsersRepository;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

@Service
public class CommonService {

    private UsersRepository usersRepository;
    private RolesRepository rolesRepository;
    private BidangRepository bidangRepository;
    private InstansiRepository instansiRepository;

    public CommonService(UsersRepository usersRepository,
                                RolesRepository rolesRepository,
                                BidangRepository bidangRepository,
                                InstansiRepository instansiRepository) {
        this.usersRepository = usersRepository;
        this.rolesRepository = rolesRepository;
        this.bidangRepository = bidangRepository;
        this.instansiRepository = instansiRepository;
    }

    public void validateUserRequst(UsersRequest input) {

        var roles= rolesRepository.findByIdAndIsDeleteFalse(input.getRoleId());
        if (roles.isEmpty()) {
            throw new BusinessException("err", "err", "err");
        }

        var bidang= bidangRepository.findByIdAndIsDeleteFalse(input.getBidangId());
        if (bidang.isEmpty()) {
            throw new BusinessException("err", "err", "err");
        }

        var instansi= instansiRepository.findByIdAndIsDeleteFalse(input.getInstansiId());
        if (instansi.isEmpty()) {
            throw new BusinessException("err", "err", "err");
        }
    }
}
